import java.awt.*;
import java.applet.*;
import java.lang.*;
import netscape.javascript.*;


public class ChatClient extends Applet implements ISession
{
	JSObject		m_JScriptWin;

	public String			m_strMessageHandler;
	public String			m_strErrorHandler;


	public void init()
	{
		super.init();

		// Get the JavaScript window that will have the various scripts that
		// this applet will call.
		m_JScriptWin = JSObject.getWindow(this);

		m_strMessageHandler = getParameter("MessageHandler");
		m_strErrorHandler = getParameter("ErrorHandler");
	}

	public void start()
	{
	}

	public void stop()
	{
	}

	public int BeginSession(String strAuthor, String strOptions, String strType, String strMessage)
	{
		return SendMessage(strAuthor, strType, strMessage);
	}

	public int EndSession(String strAuthor, String strType, String strMessage)
	{
		return SendMessage(strAuthor, strType, strMessage);
	}

	public int SendMessage(String strAuthor, String strType, String strMessage)
	{
		if (strAuthor.length() < 0)
			return HandleSessionError(1, "Invalid author specified.");

		if (strMessage.length() < 0)
			return HandleSessionError(2, "Empty message");

		if (m_strMessageHandler == null)
		{
			m_strMessageHandler = "HandleSessionMessage";
		}

		if (m_JScriptWin != null)
		{
			String Arguments[] = {strAuthor, strType, strMessage};
			m_JScriptWin.call(m_strMessageHandler, Arguments);
		}

		return 0;
	}

	public int HandleSessionError(int iNumber, String strDescription)
	{
		System.out.println(iNumber + " : " + strDescription);

		if (m_strErrorHandler == null)
		{
			m_strErrorHandler = "HandleSessionError";
		}

		if (m_JScriptWin != null)
		{
			String Arguments[] = {Integer.toString(iNumber), strDescription};
			m_JScriptWin.call(m_strErrorHandler, Arguments);
		}

		return iNumber;
	}
}
